## Vanara.PInvoke.Accessibility  
PInvoke API (methods, structures and constants) for Windows Accessibility Features.

- Includes methods from oleacc.dll  
- Current NuGet release: [![Nuget](https://img.shields.io/nuget/v/Vanara.PInvoke.Accessibility?logo=nuget&style=flat-square)![Nuget](https://img.shields.io/nuget/dt/Vanara.PInvoke.Accessibility?label=%20&style=flat-square)](https://www.nuget.org/packages/Vanara.PInvoke.Accessibility)  
### Methods - 100% API coverage (15 of 15 functions)  
Native Method | Header | Managed Method  
--- | --- | ---  
[AccessibleChildren](https://www.google.com/search?num=5&q=AccessibleChildren+site%3Alearn.microsoft.com) | oleacc.h | [Vanara.PInvoke.Oleacc.AccessibleChildren](https://github.com/dahall/Vanara/search?l=C%23&q=AccessibleChildren)  
[AccessibleObjectFromEvent](https://www.google.com/search?num=5&q=AccessibleObjectFromEvent+site%3Alearn.microsoft.com) | oleacc.h | [Vanara.PInvoke.Oleacc.AccessibleObjectFromEvent](https://github.com/dahall/Vanara/search?l=C%23&q=AccessibleObjectFromEvent)  
[AccessibleObjectFromPoint](https://www.google.com/search?num=5&q=AccessibleObjectFromPoint+site%3Alearn.microsoft.com) | oleacc.h | [Vanara.PInvoke.Oleacc.AccessibleObjectFromPoint](https://github.com/dahall/Vanara/search?l=C%23&q=AccessibleObjectFromPoint)  
[AccessibleObjectFromWindow](https://www.google.com/search?num=5&q=AccessibleObjectFromWindow+site%3Alearn.microsoft.com) | oleacc.h | [Vanara.PInvoke.Oleacc.AccessibleObjectFromWindow](https://github.com/dahall/Vanara/search?l=C%23&q=AccessibleObjectFromWindow)  
[AccNotifyTouchInteraction](https://www.google.com/search?num=5&q=AccNotifyTouchInteraction+site%3Alearn.microsoft.com) | oleacc.h | [Vanara.PInvoke.Oleacc.AccNotifyTouchInteraction](https://github.com/dahall/Vanara/search?l=C%23&q=AccNotifyTouchInteraction)  
[AccSetRunningUtilityState](https://www.google.com/search?num=5&q=AccSetRunningUtilityState+site%3Alearn.microsoft.com) | oleacc.h | [Vanara.PInvoke.Oleacc.AccSetRunningUtilityState](https://github.com/dahall/Vanara/search?l=C%23&q=AccSetRunningUtilityState)  
[CreateStdAccessibleObject](https://www.google.com/search?num=5&q=CreateStdAccessibleObject+site%3Alearn.microsoft.com) | oleacc.h | [Vanara.PInvoke.Oleacc.CreateStdAccessibleObject](https://github.com/dahall/Vanara/search?l=C%23&q=CreateStdAccessibleObject)  
[CreateStdAccessibleProxy](https://www.google.com/search?num=5&q=CreateStdAccessibleProxyA+site%3Alearn.microsoft.com) | oleacc.h | [Vanara.PInvoke.Oleacc.CreateStdAccessibleProxy](https://github.com/dahall/Vanara/search?l=C%23&q=CreateStdAccessibleProxy)  
[GetOleaccVersionInfo](https://www.google.com/search?num=5&q=GetOleaccVersionInfo+site%3Alearn.microsoft.com) | oleacc.h | [Vanara.PInvoke.Oleacc.GetOleaccVersionInfo](https://github.com/dahall/Vanara/search?l=C%23&q=GetOleaccVersionInfo)  
[GetProcessHandleFromHwnd](https://www.google.com/search?num=5&q=GetProcessHandleFromHwnd+site%3Alearn.microsoft.com) |  | [Vanara.PInvoke.Oleacc.GetProcessHandleFromHwnd](https://github.com/dahall/Vanara/search?l=C%23&q=GetProcessHandleFromHwnd)  
[GetRoleText](https://www.google.com/search?num=5&q=GetRoleTextA+site%3Alearn.microsoft.com) | oleacc.h | [Vanara.PInvoke.Oleacc.GetRoleText](https://github.com/dahall/Vanara/search?l=C%23&q=GetRoleText)  
[GetStateText](https://www.google.com/search?num=5&q=GetStateTextA+site%3Alearn.microsoft.com) | oleacc.h | [Vanara.PInvoke.Oleacc.GetStateText](https://github.com/dahall/Vanara/search?l=C%23&q=GetStateText)  
[LresultFromObject](https://www.google.com/search?num=5&q=LresultFromObject+site%3Alearn.microsoft.com) | oleacc.h | [Vanara.PInvoke.Oleacc.LresultFromObject](https://github.com/dahall/Vanara/search?l=C%23&q=LresultFromObject)  
[ObjectFromLresult](https://www.google.com/search?num=5&q=ObjectFromLresult+site%3Alearn.microsoft.com) | oleacc.h | [Vanara.PInvoke.Oleacc.ObjectFromLresult](https://github.com/dahall/Vanara/search?l=C%23&q=ObjectFromLresult)  
[WindowFromAccessibleObject](https://www.google.com/search?num=5&q=WindowFromAccessibleObject+site%3Alearn.microsoft.com) | oleacc.h | [Vanara.PInvoke.Oleacc.WindowFromAccessibleObject](https://github.com/dahall/Vanara/search?l=C%23&q=WindowFromAccessibleObject)  
### Enumerations  
Native Enum | Header | Managed Enum  
--- | --- | ---  
[AccessibilityRole](https://www.google.com/search?num=5&q=AccessibilityRole+site%3Alearn.microsoft.com) |  | [Vanara.PInvoke.Oleacc.AccessibilityRole](https://github.com/dahall/Vanara/search?l=C%23&q=AccessibilityRole)  
[AccessibilityState](https://www.google.com/search?num=5&q=AccessibilityState+site%3Alearn.microsoft.com) |  | [Vanara.PInvoke.Oleacc.AccessibilityState](https://github.com/dahall/Vanara/search?l=C%23&q=AccessibilityState)  
[ANRUS](https://www.google.com/search?num=5&q=ANRUS+site%3Alearn.microsoft.com) | oleacc.h | [Vanara.PInvoke.Oleacc.ANRUS](https://github.com/dahall/Vanara/search?l=C%23&q=ANRUS)  
[NAVDIR](https://www.google.com/search?num=5&q=NAVDIR+site%3Alearn.microsoft.com) | Oleacc.h | [Vanara.PInvoke.Oleacc.NAVDIR](https://github.com/dahall/Vanara/search?l=C%23&q=NAVDIR)  
[SELFLAG](https://www.google.com/search?num=5&q=SELFLAG+site%3Alearn.microsoft.com) | Oleacc.h | [Vanara.PInvoke.Oleacc.SELFLAG](https://github.com/dahall/Vanara/search?l=C%23&q=SELFLAG)  
### Interfaces  
Native Interface | Header | Managed Interface  
--- | --- | ---  
[IAccessible](https://www.google.com/search?num=5&q=IAccessible+site%3Alearn.microsoft.com) |  |   
[IAccessibleHandler](https://www.google.com/search?num=5&q=IAccessibleHandler+site%3Alearn.microsoft.com) |  |   
[IAccIdentity](https://www.google.com/search?num=5&q=IAccIdentity+site%3Alearn.microsoft.com) |  |   
[IAccPropServer](https://www.google.com/search?num=5&q=IAccPropServer+site%3Alearn.microsoft.com) |  |   
[IAccPropServices](https://www.google.com/search?num=5&q=IAccPropServices+site%3Alearn.microsoft.com) |  |   
