﻿![Vanara](https://raw.githubusercontent.com/dahall/Vanara/master/docs/icons/VanaraHeading.png)
### **Vanara.PInvoke.ComCtl32 NuGet Package**
[![Version](https://img.shields.io/nuget/v/Vanara.PInvoke.ComCtl32?label=NuGet&style=flat-square)](https://github.com/dahall/Vanara/releases)
[![Build status](https://img.shields.io/appveyor/build/dahall/vanara?label=AppVeyor%20build&style=flat-square)](https://ci.appveyor.com/project/dahall/vanara)

PInvoke API (methods, structures and constants) imported from Windows ComCtl32.dll.

### **What is Vanara?**

[Vanara](https://github.com/dahall/Vanara) is a community project that contains various .NET assemblies which have P/Invoke functions, interfaces, enums and structures from Windows libraries. Each assembly is associated with one or a few tightly related libraries.

### **Issues?**

First check if it's already fixed by trying the [AppVeyor build](https://ci.appveyor.com/nuget/vanara-prerelease).
If you're still running into problems, file an [issue](https://github.com/dahall/Vanara/issues).

### **Included in Vanara.PInvoke.ComCtl32**

Functions | Enumerations | Structures | Interfaces
--- | --- | --- | ---
_TrackMouseEvent CreateMappedBitmap CreatePropertySheetPage CreateUpDownControl DefSubclassProc DestroyPropertySheetPage DPA_Clone DPA_Create DPA_CreateEx DPA_DeleteAllPtrs DPA_DeletePtr DPA_Destroy DPA_DestroyCallback DPA_EnumCallback DPA_GetPtr DPA_GetPtrIndex DPA_GetSize DPA_Grow DPA_InsertPtr DPA_LoadStream DPA_Merge DPA_SaveStream DPA_Search DPA_SetPtr DPA_Sort DrawInsert DrawShadowText DrawStatusText DSA_Clone DSA_Create DSA_DeleteAllItems DSA_DeleteItem DSA_Destroy DSA_DestroyCallback DSA_EnumCallback DSA_GetItem DSA_GetItemPtr DSA_GetSize DSA_InsertItem DSA_SetItem DSA_Sort GetEffectiveClientRect GetMUILanguage GetWindowSubclass HIMAGELIST_QueryInterface ImageList_CoCreateInstance ImageList_Create ImageList_Destroy ImageList_Duplicate ImageList_GetIcon ImageList_LoadImage ImageList_Read ImageList_ReadEx ImageList_Write ImageList_WriteEx InitCommonControlsEx InitMUILanguage LBItemFromPt LoadIconMetric LoadIconWithScaleDown MakeDragList MenuHelp PropertySheet RemoveWindowSubclass SetWindowSubclass ShowHideMenuCtl Str_SetPtrW TaskDialog TaskDialogIndirect                                                                                | ButtonImageListAlign SplitButtonInfoMask SplitButtonInfoStyle CBEN_ENDEDIT_FLAG ComboBoxExItemMask ComboBoxExMessage ComboBoxExStyle CommonControlClass CommonControlNotification CustomDrawItemState CustomDrawResponse CustomDrawStage HotItemChangeFlags LI_METRIC HDSIL HeaderHitTestFlag HeaderItemFilterType HeaderItemFormat HeaderItemImageDisplay HeaderItemMask HeaderItemState HeaderMessage HeaderNotification HeaderStyle ILC ILDI ILFIP ILGOS ILP ILR IMAGELISTCOPYFLAG IMAGELISTDRAWFLAGS IMAGELISTITEMFLAG IMAGELISTSTATEFLAGS IPAddressMessage IPAddressNotification DL EMF ListViewArrange ListViewBkImageFlag ListViewColumMask ListViewColumnFormat ListViewFindInfoFlag ListViewGroupAlignment ListViewGroupMask ListViewGroupMetricsMask ListViewGroupRect ListViewGroupState ListViewHitTestFlag ListViewImageList ListViewInsertMarkFlag ListViewItemMask ListViewItemRect ListViewItemState ListViewMessage ListViewNextItemFlag ListViewNotification ListViewStyle ListViewStyleEx ListViewTileViewFlag ListViewTileViewMask LV_VIEW LVFF LVFIF LVFIS LVGIT LVKF LVSICF CommonControlMessage ProgressMessage ProgressState ProgressStyle PropSheetCallbackMessage PropSheetFlags PropSheetHeaderFlags PropSheetPageCallbackAction SBT LIF LIS LWS SysLinkMessage TabControlHitTestFlags TabControlItemMask TabControlItemStates TabControlMessage TabControlNotification TabControlStyles TabControlStylesEx TASKDIALOG_COMMON_BUTTON_FLAGS TASKDIALOG_ELEMENTS TASKDIALOG_FLAGS TASKDIALOG_ICON_ELEMENTS TaskDialogIcon TaskDialogMessage TaskDialogNotification CMB HICF HIST IDB STD TBBF TBCDRF TBDDRET TBIF TBIMHT TBMF TBNF TBSTATE ToolbarMessage ToolbarNotification ToolbarStyle ToolbarStyleEx VIEW ToolTipIcon ToolTipInfoFlags ToolTipMessage ToolTipNotification TTDT TrackBarCustomDraw TrackBarMessage TrackBarNotification TrackBarScrollNotification TrackBarStyle TrackBarTipSide AsyncDrawRetFlags TreeViewActionFlag TreeViewExpandFlags TreeViewHitTestFlags TreeViewInsert TreeViewItemMask TreeViewItemStates TreeViewItemStatesEx TreeViewMessage TreeViewNotification TreeViewNotificationReturnBehavior TreeViewSelChangedCause TreeViewSetBorderFlags TreeViewSetImageListType TreeViewStyle TreeViewStyleEx TVITEMPART UpDownMessage UpDownNotification UpDownStyle DPAM DPAMM DPAS  | BUTTON_IMAGELIST BUTTON_SPLITINFO NMBCDROPDOWN NMBCHOTITEM NMCBEDRAGBEGIN NMCBEENDEDIT NMCOMBOBOXEX COMBOBOXEXITEM COLORSCHEME INITCOMMONCONTROLSEX NMCHAR NMCUSTOMDRAW NMCUSTOMSPLITRECTINFO NMCUSTOMTEXT NMKEY NMMOUSE NMOBJECTNOTIFY NMTOOLTIPSCREATED HDTEXTFILTER HDHITTESTINFO HDITEM HDLAYOUT NMHDDISPINFO NMHDFILTERBTNCLICK NMHEADER IMAGEINFO IMAGELISTSTATS IMAGELISTDRAWPARAMS NMIPADDRESS DRAGLISTINFO LVFINDINFO LVFOOTERINFO LVFOOTERITEM LVGROUPMETRICS LVHITTESTINFO LVINSERTGROUPSORTED LVINSERTMARK LVITEMCOLUMNINFO LVITEMINDEX LVTILEVIEWINFO NMITEMACTIVATE NMLISTVIEW NMLVCACHEHINT NMLVDISPINFO NMLVEMPTYMARKUP NMLVFINDITEM NMLVGETINFOTIP NMLVKEYDOWN NMLVLINK NMLVODSTATECHANGE NMLVSCROLL LVBKIMAGE LVCOLUMN LVGROUP LVITEM LVTILEINFO PBRANGE PROPSHEETHEADER PROPSHEETPAGE LHITTESTINFO LITEM NMLINK NMTCKEYDOWN TCHITTESTINFO TCITEM TCITEMHEADER TASKDIALOG_BUTTON TASKDIALOGCONFIG COLORMAP NMTBCUSTOMDRAW NMTBDISPINFO NMTBDUPACCELERATOR NMTBGETINFOTIP NMTBHOTITEM NMTBRESTORE NMTBSAVE NMTBWRAPACCELERATOR NMTBWRAPHOTITEM NMTOOLBAR TBADDBITMAP TBBUTTON TBBUTTONINFO TBINSERTMARK TBMETRICS TBREPLACEBITMAP TBSAVEPARAMS NMTTDISPINFO TOOLINFO TTGETTITLE TTHITTESTINFO NMTRBTHUMBPOSCHANGING HTREEITEM NMTREEVIEW NMTVASYNCDRAW NMTVCUSTOMDRAW NMTVDISPINFO NMTVDISPINFOEX NMTVGETINFOTIP NMTVITEMCHANGE NMTVKEYDOWN TVHITTESTINFO TVINSERTSTRUCT TVITEM TVITEMEX TVSORTCB TVGETITEMPARTRECTINFO NMUPDOWN UDACCEL DPASTREAMINFO                                        | IImageList IImageList2                                                                                                                                                  
