﻿![Vanara](https://raw.githubusercontent.com/dahall/Vanara/master/docs/icons/VanaraHeading.png)
### **Vanara.Windows.Forms NuGet Package**
[![Version](https://img.shields.io/nuget/v/Vanara.Windows.Forms?label=NuGet&style=flat-square)](https://github.com/dahall/Vanara/releases)
[![Build status](https://img.shields.io/appveyor/build/dahall/vanara?label=AppVeyor%20build&style=flat-square)](https://ci.appveyor.com/project/dahall/vanara)

Classes for user interface related items derived from the Vanara PInvoke libraries. Includes extensions for almost all common controls to give post Vista capabilities, WinForms controls (panel, commandlink, enhanced combo boxes, IPAddress, split button, trackbar and themed controls), shutdown/restart/lock control, buffered painting, resource files, access control editor, simplifed designer framework for Windows.Forms.

### **What is Vanara?**

[Vanara](https://github.com/dahall/Vanara) is a community project that contains various .NET assemblies which have P/Invoke functions, interfaces, enums and structures from Windows libraries. Each assembly is associated with one or a few tightly related libraries.

### **Issues?**

First check if it's already fixed by trying the [AppVeyor build](https://ci.appveyor.com/nuget/vanara-prerelease).
If you're still running into problems, file an [issue](https://github.com/dahall/Vanara/issues).

### **Included in Vanara.Windows.Forms**

Classes | Structures | Enumerations | Interfaces
--- | --- | --- | ---
AccessControlEditorDialog ActivationContext AttributedComponentDesigner AttributedComponentDesignerEx AttributedControlDesigner AttributedControlDesignerEx AttributedDesignerActionList AttributedParentControlDesigner AttributedParentControlDesignerEx AuthenticationBuffer BufferedAnimationPainter BufferedPaint BufferedPainter ButtonClickedEventArgs ButtonExtension CollapsiblePanel ComboBoxExtension CommandLink ComponentDesignerExtension ControlExtension ControlImage CredentialsDialog CursorExtension CustomButton CustomComboBox CustomDrawBase DesignerActionMethodAttribute DesignerActionPropertyAttribute DesignerVerbAttribute DesktopWindowManager DisabledItemComboBox DrawPattern EditorServiceContext EnumComboBox ExpandedEventArgs ExplorerBrowser ExplorerBrowserPaneVisibility FlagCheckedListBox FlagCheckedListBoxItem FlagEnumUIEditor FolderBrowserDialog FolderBrowserDialogInitializedEventArgs GenericProvider GetDuration GlassExtenderProvider GraphicsExtension GroupIconResIndexer IconExtension ImageListExtension ImageResIndexer InputDialog InputDialogItemAttribute InvalidFolderEventArgs IPAddressBox IPAddressFieldChangedEventArgs LabelExtension ListViewExtension ListViewGroupingSet LiveThumbnail MapPointExtension MenuStripMRUManager NavigatedEventArgs NavigatingEventArgs NavigationFailedEventArgs NavigationLog NavigationLogEventArgs NetworkConnectionDialog NetworkDisconnectDialog NotifyIconExtensions PaintAction PasswordValidatorEventArgs PreventShutdownContext ProgressDialog ProgressEventArgs RedirectedDesignerItemAttribute ResourceFile ServiceProviderExtension ShellNamespaceTreeControl ShellNamespaceTreeControlCancelEventArgs ShellNamespaceTreeControlEventArgs ShellNamespaceTreeControlItemLabelEditEventArgs ShellNamespaceTreeControlItemMouseClickEventArgs ShellNamespaceTreeRootList ShellProgressDialog SplitButton SplitMenuEventArgs StringResIndexer Style TaskDialog TaskDialogButton TaskDialogButtonBase TaskDialogButtonCollection TaskDialogProgressBar TaskDialogRadioButton TextBoxExtension ThemedImageDraw ThemedLabel ThemedPanel ThemedTableLayoutPanel TimerEventArgs TrackBarEx TreeViewExtension TypedBehavior TypedDesignerActionList TypedGlyph VerificationClickedEventArgs VistaButtonBase VistaControlExtender VisualStylesRendererExtension VisualTheme  | TaskDialogResult                                                                                                               | BitmapProperty BoolProperty CloakingSource CollapsiblePanelBorderCondition CollapsiblePanelHeaderState ColorProperty ControlState EnumProperty ExplorerBrowserContentSectionOptions ExplorerBrowserLoadFlags ExplorerBrowserNavigateOptions ExplorerBrowserNavigationItemCategory ExplorerBrowserViewMode FilenameProperty Flip3DWindowPolicy FolderBrowserDialogOptions FontProperty IconSize IntProperty ItemHitLocation KnownFolder MarginsProperty MetricProperty NonClientRenderingPolicy PaneVisibilityState PartSize PositionProperty ProgressBarState PropertyOrigin RectangleProperty RenderStyle SecurityPageType ShellNamespaceTreeControlAction ShellProgressDialogStyle ShellTreeItemButton ShellTreeItemCheckBoxStyle ShellTreeItemState SizeMode StringProperty TaskDialogButtonDisplay TaskDialogCommonButtons TaskDialogIcon                                                                      | IAccessControlEditorDialogProvider IActionGetItem IDrawingStyle IEnableable                                                                                                           
